{    var   : }
{ K, H, F, M }
Unit DE44E_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE70EK_p, DE70EH_p, DE70E0_p, DE71EE_p, DE71EF_p, DE70EI_p, DE70EF_p;

procedure DE44E(F :Proc_F70E; var M :Integer; var K :Integer;
                INIAPR :Integer; IMAX :Integer; var JSTART :Integer;
                var YX :Array of Extended; var X :Extended;
                var XJ0 :Array of Extended; var AU :Array of Extended;
                var AJK :Array of Extended; var H :Extended;
                var HD4I :Array of Extended; var RABC :Array of Extended;
                var ALP :Array of Extended; var ALPN :Array of Extended;
                var CMAR :Array of Extended; var P :Array of Extended;
                var S :Array of Extended; var XP :Extended;
                var YP :Array of Extended; var AJKP :Array of Extended;
                var U :Array of Extended; var ZFI :Array of Extended);

implementation

procedure DE44E(F :Proc_F70E; var M :Integer; var K :Integer;
                INIAPR :Integer; IMAX :Integer; var JSTART :Integer;
                var YX :Array of Extended; var X :Extended;
                var XJ0 :Array of Extended; var AU :Array of Extended;
                var AJK :Array of Extended; var H :Extended;
                var HD4I :Array of Extended; var RABC :Array of Extended;
                var ALP :Array of Extended; var ALPN :Array of Extended;
                var CMAR :Array of Extended; var P :Array of Extended;
                var S :Array of Extended; var XP :Extended;
                var YP :Array of Extended; var AJKP :Array of Extended;
                var U :Array of Extended; var ZFI :Array of Extended);
var
KP1,KP2,L,J,IEXIT,NU :Integer;
KSI :Extended;
label
_45,_50,_55,_60,_65,_70,_80,_85,_90,_95,_100,_110,_120,_200;
begin
KP1 := K+1;
KP2 := K+2;
XP := X;
for L:=1 to M do
 begin
_45:
  YP[L-1] := YX[L-1];
 end;
if ( JSTART <> 0 ) 
 then goto _55;
{  }
{        THE FIRST STEP REALIZATION }
{        CALCULATION OF ALL VARIABLES DEPENDING ON K }
{  }
DE70eK(K,RABC,ALP,ALPN,CMAR,P,S);
{  }
{        CALCULATION OF ALL VARIABLES DEPENDING ON H }
{        AND ALSO VARIABLES DEPENDING ON H AND K }
{  }
DE70eH(K,H,HD4I);
for J:=1 to K do
 begin
_50:
  XJ0[J-1] := XP+ALP[J-1]*H;
 end;
DE70e0(F,M,K,XP,YP,XJ0,ALPN,CMAR,AJK,AU,U,ZFI);
goto _110;
{  }
{        THE NEXT STEP REALIZATION }
{  }
_55:
for J:=1 to K do
 begin
_60:
  XJ0[J-1] := XP+ALP[J-1]*H;
 end;
{        CHEBYSHEV COEFFICIENTS FROM PREVIOUS STEP ARE STORED }
for J:=1 to KP1 do
 begin
  for L:=1 to M do
   begin
_65:
    AJKP[(L-1)+(J-1)*M] := AJK[(L-1)+(J-1)*M];
   end;
_70:
 end;
if ( H = _COM70D.elm7 )
 then goto _80;
KSI := H/_COM70D.elm7;
{        RECALCULATION OF ALL VARIABLS DEPENDING ON H }
DE70eH(K,H,HD4I);
_80:
if ( INIAPR <> 1 )
 then goto _85;
{        CALCULATE INITIAL APPROXIMATION FROM INITIAL CONDITION ALWAYS }
DE70e0(F,M,K,XP,YP,XJ0,ALPN,CMAR,AJK,AU,U,ZFI);
goto _110;
{        CALCULATE INITIAL APPROXIMATION BY EXTRAPOLATION OF COEFFICIENTS }
{        AJK FROM PREVIOUS STEP }
_85:
if ( H = _COM70D.elm7 )
 then goto _90;
DE71eE(M,K,P,AJK,KSI,ZFI[0+(KP2-1)*M]);
goto _95;
_90:
DE71eF(M,K,S,AJK,ZFI[0+(KP2-1)*M]);
_95:
F(XP,YP,ZFI[0+0*M],M);
for L:=1 to M do
 begin
_100:
  ZFI[(L-1)+0*M] := ZFI[(L-1)+0*M]*_COM70D.elm2;
 end;
_110:
IEXIT := 0;
for NU:=1 to IMAX do
 begin
  DE70eI(F,M,K,IEXIT,YP,XJ0,AJK,HD4I,RABC,ALPN,CMAR,AU,U,ZFI);
_120:
 end;
IEXIT := 3;
DE70eI(F,M,K,IEXIT,YP,XJ0,AJK,HD4I,RABC,ALPN,CMAR,AU,U,ZFI);
DE70eF(M,KP1,AU,YX);
X := XP+H;
_COM70D.elm7 := H;
JSTART := 1;
_200:
end;

end.
